.( Compiling    MOVES.FTH Version 2.64 ) cr
" MOVES.FTH Entry" stackCheck

invisible
22 WORD array 	RezeroStats

0  offset .RSCount
2  offset .RSLastIndex
4  offset .RSGrossErrorCount
6  offset .RSSmallErrorCount
8  offset .RSMaxError
10 offset .RSSumError
14 offset .RSSum|Error|
18 offset .RSSumError2

visible nocase

: SetCurrentSpeed word: mno float: speed

	mno 1.0 SetSpeedFactor
	speed 0.0 d> if
	  mno
	  speed mno GetSpeed f/ 1.0 fmin
	  SetSpeedFactor
	endif
;

: ClearRezeroStats ds> >es 0 RezeroStats 44 0 fill ;
: pitch<0? ( mno - flag )

	4* M_PITCH + 2- @ $8000 and ( sign of pitch )
;

ClearRezeroStats


: RSDump

local
0 RezeroStats word: p

."     Count   Last    #Gross  #Small  Max     Sum     |Sum|   Sum2    " cr

cr cr
where 2- const word: y word: x

	0 begin

		0  over y + at ascii X over + emit ."  : "
		4  over y + at p @ .RSCount @ .
		12 over y + at p @ .RSLastIndex @ .
		20 over y + at p @ .RSGrossErrorCount @ .
		28 over y + at p @ .RSSmallErrorCount @ .
		36 over y + at p @ .RSMaxError @ .
		44 over y + at p @ .RSSumError 2@ d.
		52 over y + at p @ .RSSum|Error| 2@ d.
		60 over y + at p @ .RSSumError2 2@ d.
		22 p +!
	1+ dup 2 = until drop
	cr
;



decimal
" MOVES::windup" stackCheck

: windup word: mno 				( mno - )
	mno setPhase0 50 steps/sec 0 actuate
	mno pitch<0? if mno 24L else mno -24L then stepBy 0 actuate
	mno 0 motorPower	( relax )
;
: backoff word: mno word: assertPos 	( mno, assertPosition - )
	mno assertPos cwd setStepPosition
	mno 1 motorPower
	mno pitch<0? if mno -8L else mno 8L then stepTo 0 actuate
;

: shutDown

	clearSteps
	12 1 do
		i setPhase0
	loop
	20 steps/sec 0 actuate
	off
;

: rezero	word: mno word: assertPos

	clearSteps
	mno windup
	1000 ms
	mno assertPos backoff
	mno reset
;

: RezeroLS word: Axis

local

Axis AxisChannel c@ 			const word: mno
mno 2 motorPower			const word: checking?
0 RezeroStats Axis if 22 + endif 	const word: ptr


	clearSteps
	mno -400.0 moveBy 52 AxisActuate.

	clearSteps
	steps/cycle 25 * steps/sec
	mno 50.0 moveBy
	$310 actuate

mno getStepPosition drop 	const word: posNow
Axis AxisOffset @		const word: indexPos
posNow indexPos - 		const word: diff
diff steps/cycle 2/ +
steps/cycle 1- not and 		const word: delta


	checking? if
	  ptr .RSCount ++
	  posNow ptr .RSLastIndex !
	  diff cwd ptr .RSSumError d+!
	  diff abs cwd ptr .RSSum|Error| d+!
	  diff cwd 2dup d* ptr .RSSumError2 d+!

	  delta abs steps/cycle 2* >= if
		ptr .RSGrossErrorCount ++
	  else
		delta if ptr .RSSmallErrorCount ++ endif
	  endif

	  diff abs ptr .RSMaxError @ abs > if diff ptr .RSMaxError ! endif
	endif

	delta if

		mno  posNow delta -
		cwd setStepPosition
	endif

	mno 0.0 moveTo 4 actuate
;

: SyringeRezero word: Syringes

local 1 word: mask


	clearSteps
	6 0 do
	  mask @ Syringes and if
	    i SyringeChannel c@
	    dup 1.0 SetSpeedFactor
	    dup GetLength -1.1 f* moveBy
	  endif
	  mask @ mask +!
	loop
	46 SyringeActuate.

	clearSteps
	1 mask !
	6 0 do
	  mask @ Syringes and if
	    i SyringeChannel c@ setPhase0
	  endif
	  mask @ mask +!
	loop
	0 actuate

	1 mask !
	6 0 do
	  mask @ Syringes and if
	    i SyringeChannel c@
	    dup 0L setStepPosition
	    0 MotorPower
	  endif
	  mask @ mask +!
	loop
	1 UpdateSyringes

;

12 variable 	oilAxis
1  variable 	protSyr
2  variable 	solSyr
6  variable 	oilSyr

: ArmGoto word: Arm   float: TargetHeight  float: SlowSpeed  float: SlowHeight

local Arm if vAxis else zAxis endif const word: mno

	clearSteps

	SlowHeight mno GetLPosition
	d> if	( start in slow area )

	  mno SlowSpeed SetCurrentSpeed
	  TargetHeight SlowHeight

	  d> if	( need move to SlowHeight )
	    mno SlowHeight MoveLTo 46 AxisActuate. eCheck
	    mno 1.0 setSpeedFactor
	  endif

	else

	  mno 1.0 setSpeedFactor
	  TargetHeight SlowHeight

	  d< if
	    mno SlowHeight MoveLTo 46 AxisActuate. eCheck
	    mno SlowSpeed SetCurrentSpeed
	  endif

	endif

	mno TargetHeight MoveLTo 46 AxisActuate. eCheck
;

: SyringeMove ( sno, diff., ... , n, actuateMode - )

	clearSteps
	>r
	0 do rot SyringeChannel c@ -rot moveLBy loop
	r> SyringeActuate. eCheck
;

: wiggle word: axis float: distance word: ntimes

	ntimes 0 do
	  axis distance moveBy 46 AxisActuate. eCheck
	  axis distance fnegate moveBy 46 AxisActuate. eCheck
	loop
;

case

17 variable oilVol
-188 variable lipStepRadius
0  variable oilCounter
20 variable nMoves
32 constant oilMode
200 variable vX
350 variable vY


BYTE table StirTable
	1 c,	1 c,	-1 c,	-2 c,
	-1 c,	1 c,	2 c,	-1 c,
	-1 c,	2 c,	-1 c,	-1 c,	1 c,

" MOVES::StirTable" stackCheck

: doStir float: mm word: stirno

	clearSteps
local	xAxis getPitch mm f* ftol drop 1+ 2/ const word: sX
	yAxis getPitch mm f* ftol drop 1+ 2/ const word: sY

	stirno 0 do
		." Stir " i 1+ . cr
		13 0 do
			i StirTable cbw
			i 1 and if
			  yAxis swap sY
			else
			  xAxis swap sX
			endif
			* cwd stepBy 36 actuate

			stepError @ if leave endif
		loop
		stepError @ if leave endif
	loop
;
" MOVES::doStir" stackCheck

20 BYTE array 	lipStepX
20 BYTE array 	lipStepY

: setLipStepX word: value word: index

	value index lipStepX c!
	value 19 index - lipStepX c!
	value negate index 10 + lipStepX c!
	value negate 9 index - lipStepX c!
;

: setLipStepY word: value word: index

	value index lipStepY c!
	value 9 index - lipStepY c!
	value negate index 10 + lipStepY c!
	value negate 19 index - lipStepY c!
;


FLOAT table LipSine

0.04894 2, 0.14204 2, 0.22123 2, 0.27877 2, 0.30902 2,

: setLipRadius float: radius


local	xAxis GetPitch radius f* const float: xs
	yAxis GetPitch radius f* const float: ys
	0 word: totalX
	0 word: totalY

	4 0 do
	  i LipSine xs f* ftol drop
	  dup totalX +! i 5 + setLipStepX
	  i LipSine ys f* ftol drop
	  dup totalY +! i setLipStepY
	loop
	xs ftol drop totalX @ - 9 setLipStepX
	ys ftol drop dup lipStepRadius !
	totalY @ - 4 setLipStepY
;

: lipDump

	cr
	20 0 do
		i 4 r.
	loop
	cr
	20 0 do
		i lipStepX c@ cbw 4 r.
	loop
	20 0 do
		i lipStepY c@ cbw 4 r.
	loop
	cr
;

: nextOilVol ( - nSteps )

	0
	begin
		oilCounter @ 0>
	while
		nMoves @ oilCounter -!
		1+
	repeat
	oilVol @ oilCounter +!
;

: xyOil ( step : integer - )

	oilSyr @ nextOilVol cwd stepBy
	xAxis  over lipStepX c@ cbw cwd stepBy
	yAxis  swap lipStepY c@ cbw cwd stepBy
	44 AxisActuate. 0 UpdateSyringes
;

visible nocase

: stir		getuuf if 2swap 2drop 1 doStir endif ;
: nStirs doStir ;

: OilLip float: dOil float: Radius

	Radius setLipRadius
	dOil oilSyr @ GetPitch f* ftol drop oilVol !

	clearSteps

	oilAxis @ 0.4 setSpeedFactor oilSyr @ 0.8 setSpeedFactor
	yAxis lipStepRadius @ negate cwd stepBy oilSyr @ 1L stepBy 36 actuate?
	oilVol @ oilCounter !
	oilAxis @ 2.5 moveBy 36 actuate?
	oilAxis @ -0.5 moveBy 36 actuate? 0 UpdateAxes

	( vX @ steps/sec )

	20 0 do
	(  i 2 = i 12 = or if vY @ steps/sec then
	  i 8 = i 18 = or if vX @ steps/sec then )
	  i xyOil
	loop

	0 UpdateSyringes
	oilAxis @ -2.0 moveBy 36 actuate?

	yAxis lipStepRadius @ cwd stepBy oilSyr @ -1L stepBy 36 actuate? 0 UpdateAxes

;

: oil 0.0508 9.575 oilLip ;

: ZMoveBy float: z  zAxis z moveBy 46 AxisActuate. ;
: XYMoveBy float: x float: y  xAxis x moveBy yAxis y moveBy 46 AxisActuate. ;


: Slit

clearSteps 3 0 do i AxisChannel c@ 0.8 setSpeedFactor loop

3.0 4.0 XYMoveBy

 4.5 ZMoveBy
	 0.0 -1.0 XYMoveBy
	-6.0 -6.0 XYMoveBy
	 0.0 -1.0 XYMoveBy
-4.5 ZMoveBy

 3.0 4.0 XYMoveBy
-3.0 4.0 XYMoveBy

 4.5 	ZMoveBy
	0.0 -1.0 XYMoveBy
	3.0 -3.0 XYMoveBy
-4.5 ZMoveBy

3.0 -4.0 XYMoveBy

 4.5 ZMoveBy
	 0.0 1.0 XYMoveBy
	-3.0 3.0 XYMoveBy
-4.5 ZMoveBy
;

: Streak

clearSteps 3 0 do i AxisChannel c@ 0.8 setSpeedFactor loop

0.75 0.0 XYMoveBy
-1.5 0.0 XYMoveBy
0.75 0.0 XYMoveBy

;


: OilDrop   float: zHeight float: Smm float: SSpeed

	oilSyr @ SSpeed setSpeedFactor
	oilAxis @ 1.0 setSpeedFactor
	oilSyr @ Smm moveBy		( S movement )
	oilAxis @ zHeight MoveLTo	( V move down )
	37 actuate 0 msALL UpdateMotors
;

invisible

7 FLOAT array TrData
0 constant RINSEXOFF
1 constant RINSEYOFF
2 constant RESHEIGHT
3 constant SHELFCLEARANCE
4 constant DROPXOFF
5 constant DROPYOFF
6 constant DROPHEIGHT

visible
: SetTransferData ( fp0 .. fp6 - ) 7 0 do 6 i - TrData 2! loop ;

0.0 2.0 3.0 6.0 4.0 0.0 5.0 SetTransferData

: TrDump 7 0 do i . i TrData 2@ f. cr loop ;

: TransferDrop word: ProtSyr float: dProt word: SolSyr
			float: dSol float: dBack

local	dSol dBack f+ const float: dGross
	SolSyr SyringeChannel c@ const word: SolChannel
	ProtSyr SyringeChannel c@ const word: ProtChannel


	." Show TipLower.bmp" cr
	xAxis RINSEXOFF TrData 2@ moveBy
	yAxis RINSEYOFF TrData 2@ moveBy
	zAxis RESHEIGHT TrData 2@ moveLTo
	46 AxisActuate.

	." Show Withdraw.bmp" cr
	SolChannel dGross MoveLBy
	302 SyringeActuate.

	SolChannel dGross MoveBy
	302 SyringeActuate.

	." Show GotoXY.bmp" cr
	xAxis RINSEXOFF TrData 2@ moveLBy
	yAxis RINSEYOFF TrData 2@ moveLBy
	46 AxisActuate.

	." Show Withdraw.bmp" cr
	SolChannel dGross MoveLBy
	302 SyringeActuate.
	SolChannel dBack MoveBy
	302 SyringeActuate.

	." Show TransferDrop.bmp" cr
	zAxis SHELFCLEARANCE TrData 2@ MoveLTo
	46 AxisActuate.

	xAxis DROPXOFF TrData 2@ moveBy
	yAxis DROPYOFF TrData 2@ moveBy
	46 AxisActuate.

	zAxis DROPHEIGHT TrData 2@ MoveLTo
	46 AxisActuate.

	." Show Dispense.bmp" cr
	SolChannel dSol MoveBy
	ProtChannel dProt MoveBy
	302 SyringeActuate.

	." Status Transfer complete." cr

;

: Blend ( SolSyr, RinseSteps, EndSteps, Fast, Slow, nCycles )

;




: nudge word: mno word: steps ( mno, steps - print:position )

	mno steps cwd stepBy 4 actuate mno GetLPosition f.
;

" MOVES.FTH Exit" stackCheck
